<?php
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if ($user->data['user_id'] == ANONYMOUS)
{
    header('Location: /ucp.php?mode=login');
    exit;
}

$request->enable_super_globals();

if (!isset($_GET["next"])) {
    http_response_code(400);
    die();
}

$next_url = $_GET["next"];

if (filter_var($next_url, FILTER_VALIDATE_URL) === false) {
    http_response_code(400);
    die();
}

if (
    substr($next_url, 0, 27) !== "https://nastenka.pirati.cz/"
    && substr($next_url, 0, 29) !== "https://nastenka.pir-test.eu/"
) {
    http_response_code(401);
    die();
}

$db->sql_query(
    'CREATE TABLE IF NOT EXISTS ' . $table_prefix . 'api_tokens (
        user_id INT(10) UNSIGNED,
        allowed_forum_ids TEXT NOT NULL,
        token VARCHAR(32) NOT NULL,
        PRIMARY KEY (user_id),
        FOREIGN KEY (user_id)
            REFERENCES ' . $table_prefix . 'users (user_id)
            ON DELETE CASCADE
    ) ENGINE=INNODB'
);

$existing_token_query = $db->sql_query(
    'SELECT user_id, token FROM ' . $table_prefix . 'api_tokens
    WHERE user_id = ' . $user->data["user_id"]
);

$token_exists = false;
$token = null;

while ($row = $db->sql_fetchrow($existing_token_query)) {
    $token_exists = true;
    $token = $row["token"];
}

if (!$token_exists) {
    http_response_code(401);
    die();
}

page_header('Synchronizace s Nástěnkou');

$desync_key = "nastenka_desync";
add_form_key($desync_key);

if ($request->is_set_post('submit')) {
    if (!check_form_key($desync_key)) {
        trigger_error('FORM_INVALID');
    }

    $db->sql_query(
        'DELETE FROM ' . $table_prefix . 'api_tokens
        WHERE user_id = ' . $user->data["user_id"]
    );

    header("Location: " . $next_url);
    die();
}

$template->set_filenames(array(
    'body' => 'nastenka_desync.html',
));
$template->assign_vars(array(
    'NEXT_URL' => $next_url
));

page_footer();
?>
