<?php
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if ($user->data['user_id'] == ANONYMOUS)
{
    header('Location: /ucp.php?mode=login');
    exit;
}

$request->enable_super_globals();

if (!isset($_GET["forum_scopes"])) {
    http_response_code(400);
    die();
}

$requested_forum_ids = explode(",", $_GET["forum_scopes"]);
$allowed_forum_ids = array();

foreach ($requested_forum_ids as &$forum_id) {
    if (!is_numeric($forum_id)) {
        http_response_code(400);
        die();
    }

    $forum_id = (int)$forum_id;

    $forum_data = null;
    $forum_query = $db->sql_query(
        'SELECT * FROM ' . $table_prefix . 'forums
        WHERE forum_id= ' . $forum_id
    );

    while ($row = $db->sql_fetchrow($forum_query)) {
        $forum_data = $row;
    }

    if ($forum_data === null) {
        http_response_code(404);
        die();
    }

    if (!(
        !$auth->acl_gets('f_list', 'f_list_topics', 'f_read', $forum_id)
        || (
            $forum_data['forum_type'] == FORUM_LINK
            && $forum_data['forum_link']
            && !$auth->acl_get('f_read', $forum_id)
        )
    )) {
        array_push($allowed_forum_ids, $forum_id);
    }
}

$db->sql_query(
    'CREATE TABLE IF NOT EXISTS ' . $table_prefix . 'api_tokens (
        user_id INT(10) UNSIGNED,
        allowed_forum_ids TEXT NOT NULL,
        token VARCHAR(32) NOT NULL,
        PRIMARY KEY (user_id),
        FOREIGN KEY (user_id)
            REFERENCES ' . $table_prefix . 'users (user_id)
            ON DELETE CASCADE
    ) ENGINE=INNODB'
);

$existing_token_query = $db->sql_query(
    'SELECT user_id, token FROM ' . $table_prefix . 'api_tokens
    WHERE user_id = ' . $user->data["user_id"]
);

$token_exists = false;
$token = null;

while ($row = $db->sql_fetchrow($existing_token_query)) {
    $token_exists = true;
    $token = $row["token"];
}

if (!$token_exists) {
    $token = bin2hex(random_bytes(16));

    $db->sql_query(
        'INSERT INTO ' . $table_prefix . 'api_tokens
        VALUES ('
            . $user->data["user_id"] . ', '
            . '\'' . implode(",", $allowed_forum_ids) . '\', '
            . '\'' . $token . '\'' .
        ')'
    );
} else {
    $db->sql_query(
        'UPDATE ' . $table_prefix . 'api_tokens
        SET allowed_forum_ids = \'' . implode(",", $allowed_forum_ids) . '\'
        WHERE user_id=' . $user->data["user_id"]
    );
}

page_header('Synchronizace s Nástěnkou');

$template->set_filenames(array(
    'body' => 'nastenka_sync.html',
));
$template->assign_vars(array(
    'TOKEN' => $token,
    'ALLOWED_FORUM_IDS' => implode(",", $allowed_forum_ids)
));

$request->disable_super_globals();

page_footer();
?>
